#!/bin/bash
#
# written by Thorsten Glebe, Jan. 1999
# Max-Planck-Institut of Nuclear Physics
# Heidelberg / Germany
#
# 1. argument: tar-file destination directory
#

DIR=`dirname $0`
source $DIR/util.sh

if [ $# -ne 1 ]; then
    echo "usage: $PROG <destination-directory>"
    exit 1
else
    DESTDIR=$1
fi

PACK_FILE=$LIBROOT/PACKAGES

# Name of the .tar file
TARFILE="${DESTDIR}/${BEEVERSION}.src.tar"

#
# remove potentially existing tar-files in vdslib
#
if [ -f "$TARFILE" ]; then
    echo "removing ${TARFILE}"
    rm $TARFILE
fi
if [ -f "${TARFILE}.gz" ]; then
    echo "removing ${TARFILE}.gz"
    rm ${TARFILE}.gz
fi

#
# tar BEE
#
set_tar
$TAR cvf $TARFILE -C ${DIR}/.. ${BEEVERSION} --exclude "*/bin/*" --exclude "*/lib/*" --exclude "*/${HBBINTYPE}/*"
check_status "error tarring ${DIR}/../${BEEVERSION}"

#
# collect packages
#
#for i in `cat $PACK_FILE | awk '!/^[ ]*#.*$/ && $2 ~ /\/[0-9]+-[0-9]+/ {gsub("/",".",$2); print $1"+"substr($2,2)}'`; do
#    NAME=`echo $i | cut -d+ -f1`
#    VERS=`echo $i | cut -d+ -f2`
#    PKGNAME=$NAME
#    if [ -d "${DIR}/${PKGNAME}" ]; then
#       $TAR rvf $TARFILE -C ${DIR} $PKGNAME 2>>$LIBROOT/ERRORS
#       check_status "error tarring $PKGNAME"
#    fi
#done

#
# gzip the tar-file
#
echo "gzip ${TARFILE}..."
gzip $TARFILE

# END
echo "done..."
exit 0
