#ifndef __TOBJECT_HH
#define __TOBJECT_HH
// *****************************************************************************
//
// source:
//
// type:      source code
//
// created:   01. Nov 2000
//
// author:    Thorsten Glebe
//            HERA-B Collaboration
//            Max-Planck-Institut fuer Kernphysik
//            Saupfercheckweg 1
//            69117 Heidelberg
//            Germany
//            E-mail: T.Glebe@mpi-hd.mpg.de
//
// Description: TObject - Interface to ROOT
//
// changes:
// 01 Nov 2000 (TG) creation
//
// *****************************************************************************
#ifdef USE_ROOT
# include <TObject.h>
#else
# ifndef _TOBJECT_
/**
   TObject is the base class for all classes which should be integrated into
   ROOT RTTI. For sake of clean code, a dummy base class is
   used in case no ROOT is present.
   @memo Dummy base class
   @author T. Glebe
*/
//==============================================================================
// GeomIni
//==============================================================================
class TObject {
public:
  ///
  TObject() {}
  ///
  TObject* Clone(void) {
    //    cerr << "TObject.hh: WrongTObject::Clone() called!!!" << endl;
    return this;
  }
}; // end of class TObject
#define _TOBJECT_

/** @name --- typedef's from ROOT Rtypes.h --- */
///
typedef char           Char_t;      //Signed Character 1 byte
///
typedef unsigned char  UChar_t;     //Unsigned Character 1 byte
///
typedef short          Short_t;     //Signed Short integer 2 bytes
///
typedef unsigned short UShort_t;    //Unsigned Short integer 2 bytes
///
typedef int            Int_t;       //Signed integer 4 bytes
///
typedef unsigned int   UInt_t;      //Unsigned integer 4 bytes
///
typedef int            Seek_t;      //File pointer
///
typedef long           Long_t;      //Signed long integer 8 bytes
///
typedef unsigned long  ULong_t;     //Unsigned long integer 8 bytes
///
typedef float          Float_t;     //Float 4 bytes
///
typedef double         Double_t;    //Float 8 bytes
///
typedef char           Text_t;      //General string
///
typedef unsigned char  Bool_t;      //Boolean (0=false, 1=true)
///
typedef unsigned char  Byte_t;      //Byte (8 bits)
///
typedef short          Version_t;   //Class version identifier
///
typedef const char     Option_t;    //Option string
///
typedef int            Ssiz_t;      //String size
///
typedef float          Real_t;      //TVector and TMatrix element type
///
typedef void         (*VoidFuncPtr_t)();  //pointer to void function
#endif /* _TOBJECT_ */
#endif /* USE_ROOT */
#endif
