//**********************************************************************
//
// source:
//
// type:      source code
//
// created:   12. Dez 2000
//
// author:    Thorsten Glebe
//            HERA-B Collaboration
//            Max-Planck-Institut fuer Kernphysik
//            Saupfercheckweg 1
//            69117 Heidelberg
//            Germany
//            E-mail: T.Glebe@mpi-hd.mpg.de
//
// Description: Class for HERA-B component id
//
// changes:
// 12 Dec 2000 (TG) creation
// 16 Aug 2001 (TG) changed return type of print()
//
//**********************************************************************
#include <iostream>
#include "clue/RsegC.hh"

//==============================================================================
// Constructors
//==============================================================================
RsegC::RsegC() : r_cmp(0) {}

RsegC::RsegC(const unsigned int rhs) : r_cmp(rhs) {}

RsegC::~RsegC() {}

RsegC& RsegC::operator= (const RsegC& rhs) { 
  r_cmp = rhs.r_cmp; 
  return *this;
}
  
//==============================================================================
// print
//==============================================================================
std::ostream& RsegC::print( std::ostream& os ) const {
    if( vxd()     ) os << "vxd ";
    if( patt()    ) os << "patt ";
    if( magt()    ) os << "magt ";
    if( muon()    ) os << "muon ";
    if( ecal()    ) os << "ecal ";
    if( tar()     ) os << "tar ";
    if( trit()    ) os << "trit ";
    if( bit7()    ) os << "bit7 ";
    if( slte()    ) os << "slte ";
    if( sltmu()   ) os << "sltmu ";
    if( bit10()   ) os << "bit10 ";
    if( bit11()   ) os << "bit11 ";
    if( bit12()   ) os << "bit12 ";
    if( bit13()   ) os << "bit13 ";
    if( bit14()   ) os << "bit14 ";
    if( bit15()   ) os << "bit15 ";
    if( bit16()   ) os << "bit16 ";
    if( bit17()   ) os << "bit17 ";
    if( bit18()   ) os << "bit18 ";
    if( bit19()   ) os << "bit19 ";
    if( bit20()   ) os << "bit20 ";
    if( bit21()   ) os << "bit21 ";
    if( bit22()   ) os << "bit22 ";
    if( bit23()   ) os << "bit23 ";
    if( slt()     ) os << "slt ";
    if( trd()     ) os << "trd ";
    if( rich()    ) os << "rich ";
    if( ptc()     ) os << "ptc ";
    if( msg()     ) os << "msg ";
    if( wch()     ) os << "wch ";
    if( sil()     ) os << "sil ";
    if( bitsign() ) os << "bitsign ";
    return os;
}

#ifdef USE_ROOT
ClassImp(RsegC)
#endif
