#ifndef CINT_PRECOMPILED_HH
#define CINT_PRECOMPILED_HH
// *****************************************************************************
//
// source:
//
// type:      source code
//
// created:   30. Nov 2000
//
// author:    Thorsten Glebe
//            HERA-B Collaboration
//            Max-Planck-Institut fuer Kernphysik
//            Saupfercheckweg 1
//            69117 Heidelberg
//            Germany
//            E-mail: T.Glebe@mpi-hd.mpg.de
//
// Description: Header file for declarations of precompiled template functions
//              which should be used in CINT. For each function a
//              #pragma statement must be added in LinkDef.hh
//
// changes:
// 30 Nov 2000 (TG) creation
// 05 Jan 2001 (TG) include gcombiner added
// 24 Jan 2001 (TG) renamed ArteDeclaration.hh to ClueDeclaration.hh
// 24 Jan 2001 (TG) removed #ifdef __CINT__, as code from ClueDeclaration.hh
//                  should end up in cluedict.C
//
// *****************************************************************************
#include "gate/GateDeclaration.hh"
#include "grelation/ClueRelationDeclaration.hh"
#include "clue/ClueDeclaration.hh"

#include "gcombiner/CombinerDeclaration.hh"
#endif
