#ifndef __CLUETTREE_HH
#define __CLUETTREE_HH
// ********************************************************************
//
// source:
//
// type:      source code
//
// created:   14. Dez 2000
//
// author:    Thorsten Glebe
//            HERA-B Collaboration
//            Max-Planck-Institut fuer Kernphysik
//            Saupfercheckweg 1
//            69117 Heidelberg
//            Germany
//            E-mail: T.Glebe@mpi-hd.mpg.de
//
// Description: My own TTree object
//
// changes:
// 14 Dec 2000 (TG) creation
//
// ********************************************************************
#ifdef USE_ROOT
#include <TTree.h>

/**
   Modified ROOT TTree class
   @author T. Glebe
*/
//==============================================================================
// ClueTTree
//==============================================================================
class ClueTTree: public TTree {
public:
  /** @name --- Constructors --- */
  ///
  ClueTTree() : TTree() {}
  ///
  ClueTTree(const char *name, const char *title, Int_t maxvirtualsize=0) :
    TTree(name, title, maxvirtualsize) {}
  ///
  virtual ~ClueTTree() {}
  
  /** @name --- Access methods --- */
  virtual TBranch  *Branch(const char *name, const char *classname,
			   void *addobj, Int_t bufsize=32000, Int_t splitlevel=1);

};
#endif  //USE_ROOT
#endif
