#ifndef PATTERNSPEC_H
#define PATTERNSPEC_H

#undef TRUE
#undef FALSE

#if defined(__CINT__) || !(__GNUC__==2 && __GNUC_MINOR__<91 )
// #warning ==========> using THIS
#define spec(t1,t2) \
template<> void ClProperty<t1,t2>::ShowMembers(TMemberInspector &, char *); \
template<> void ClProperty<t1,t2>::Streamer( TBuffer& ); \
template<> void ClMember<t1,t2>::ShowMembers(TMemberInspector &, char *); \
template<> void ClMember<t1,t2>::Streamer( TBuffer& ); \
template<> void ClConstant<t1,t2>::ShowMembers(TMemberInspector &, char *); \
template<> void ClConstant<t1,t2>::Streamer( TBuffer& );

#define specb(t1,t2) \
TBuffer& operator>>( TBuffer& buf, t2 (t1::* & )() const ) { return buf; } \
TBuffer& operator<<( TBuffer& buf, t2 (t1::* & )() const ) { return buf; };

//template <> TBuffer& operator>>( TBuffer& buf, ClMember<t1,t2>* & );
#else
// #warning =======> using that!
#define specb(t1,t2) \
TBuffer& operator>>( TBuffer& buf, t2 (t1::* & )() const ) { return buf; } \
TBuffer& operator<<( TBuffer& buf, t2 (t1::* & )() const ) { return buf; };
#endif

#if defined(__CINT__) || !(__GNUC__==2 && __GNUC_MINOR__<91 )
#define spec3(t1,t2,t3) \
template <> void ClExpression<t1,t2,t3>::ShowMembers(TMemberInspector &, char *); \
template <> void ClExpression<t1,t2,t3>::Streamer( TBuffer& );

#define spec4(t1,t2,t3,t4) \
template <> \
void ClMemberTwoPar<t1,t2,t3,t4>::ShowMembers(TMemberInspector &, char *); \
template <> void ClMemberTwoPar<t1,t2,t3,t4>::Streamer( TBuffer& );

#define spec4b(t1,t2,t3,t4) \
TBuffer& operator>>( TBuffer& buf, t2 (t1::* & )( t3, t4 ) const ) \
{ return buf; } \
TBuffer& operator<<( TBuffer& buf, t2 (t1::* & )( t3, t4 ) const ) \
{ return buf; }

#else

#define spec3(t1,t2,t3)

#define spec4(t1,t2,t3,t4) \
TBuffer& operator>>( TBuffer& buf, t2 (t1::* & )( t3, t4 ) const ) \
{ return buf; } \
TBuffer& operator<<( TBuffer& buf, t2 (t1::* & )( t3, t4 ) const ) \
{ return buf; }

#endif

#ifdef __CINT__
#else
// #include <TObject.h>

// #include <Clue/RecoTrack.hh>
// #include <Clue/Wire.hh>
#endif

#ifdef NAMESPACE
namespace CLUE {
#else
#ifndef __CINT__
#define CLUE std
#endif
#endif
spec( RecoTrack,int)
spec( RecoTrack,float)
spec3(RecoTrack,int,int)
spec3(RecoTrack,float,int)
spec3(RecoTrack,float,float)
spec4(RecoTrack,float,int,int)

spec( RecoSegment,int)
spec( RecoSegment,float)
spec3(RecoSegment,int,int)
spec3(RecoSegment,float,int)
spec3(RecoSegment,float,float)
spec4(RecoSegment,float,int,int)
#ifdef NAMESPACE
}
#endif

specb( CLUE::RecoTrack,int)
specb( CLUE::RecoTrack,float)
spec4b(CLUE::RecoTrack,float,int,int)

specb( CLUE::RecoSegment,int)
specb( CLUE::RecoSegment,float)
spec4b(CLUE::RecoSegment,float,int,int)

#endif
