#ifndef __K0Analysis_HH
#define __K0Analysis_HH
// ********************************************************************
//
// source:
//
// type:      source code
//
// created:   Mon Jul 16 18:15:43 MEST 2001
//
// author:    glebe
//
// Description: 
//
// changes:
//
// ********************************************************************

#include "interfaces/AnalysisIf.hh"

#include "pattern/SPatternMatchContainer.hh"
#include "pattern/SDecayPatternMatchContainer.hh"
#include "pattern/SPatternExpression.hh"

class TH1F;
class TH2F;
class TNtuple;
class RtEvent;

//==============================================================================
// K0Analysis
//==============================================================================
class K0Analysis : public AnalysisIf {
public:
  /** @name --- Constructors --- */
  ///
  K0Analysis(RtEvent* evt);
  ///
  virtual ~K0Analysis() {}

  /** @name --- Access methods --- */
  ///
  bool EventSelect();
  ///
  bool DefineHistograms();
  ///
  bool DefinePattern();
  ///
  bool Event();
  ///
  bool EventCleanup();
  ///
  bool End();
  ///
  inline const char *name() const { return "K0Analysis"; }

private:
  RtEvent* event;

  // --- pattern --------------------------------------
  PMC_sp Piplus;
  PMC_sp Piminus;

  // K0s -> pi+pi-
  DP_trait<2>::DPMC_sp kshort;

  TNtuple* Kshort;
}; // end of K0Analysis
#endif

