#ifndef __LambdaAnalysis_HH
#define __LambdaAnalysis_HH
// ********************************************************************
//
// source:
//
// type:      source code
//
// created:   Mon Jul 16 18:15:43 MEST 2001
//
// author:    glebe
//
// Description: 
//
// changes:
//
// ********************************************************************

#include "interfaces/AnalysisIf.hh"

#include "pattern/SPatternMatchContainer.hh"
#include "pattern/SDecayPatternMatchContainer.hh"
#include "pattern/SPatternExpression.hh"

class TH1F;
class TH2F;
class TNtuple;
class RtEvent;

//==============================================================================
// LambdaAnalysis
//==============================================================================
class LambdaAnalysis : public AnalysisIf {
public:
  /** @name --- Constructors --- */
  ///
  LambdaAnalysis(RtEvent* evt);
  ///
  virtual ~LambdaAnalysis() {}

  /** @name --- Access methods --- */
  ///
  bool EventSelect();
  ///
  bool DefineHistograms();
  ///
  bool DefinePattern();
  ///
  double Dmain(const TrackIf& track);
  ///
  double Dist(SVertex<2>& vtx);
  ///
  bool Vertexing(DP_trait<2>::DPMC_sp& cand, TNtuple* ntuple);
  ///
  bool Event();
  ///
  bool EventCleanup();
  ///
  bool End();
  ///
  inline const char *name() const { return "LambdaAnalysis"; }

private:
  RtEvent* event;

  // --- pattern --------------------------------------
  PMC_sp Piplus;
  PMC_sp Piminus;
  PMC_sp Proton;
  PMC_sp AntiProton;

  // Lambdas -> pi+pi-
  DP_trait<2>::DPMC_sp lambda;
  DP_trait<2>::DPMC_sp lambdabar;

  TNtuple* Lambda;
  TNtuple* Lambdabar;

}; // end of LambdaAnalysis
#endif

