#ifndef __MCAna_HH
#define __MCAna_HH
// ********************************************************************
//
// source:
//
// type:      source code
//
// created:   Die Aug 14 10:33:50 MEST 2001
//
// author:    glebe
//
// Description: MC Analysis class. 
//
// changes:
//
// ********************************************************************

#include "interfaces/AnalysisIf.hh"

class TH1F;
class TH2F;
class TNtuple;
class RtEvent;

//==============================================================================
// MCAna
//==============================================================================
class MCAna : public AnalysisIf {
public:
  /** @name --- Constructors --- */
  ///
  MCAna(RtEvent* evt);
  ///
  virtual ~MCAna() {}

  /** @name --- Access methods --- */
  ///
  bool EventSelect();
  ///
  bool DefineHistograms();
  ///
  bool DefinePattern();
  ///
  bool Event();
  ///
  bool EventCleanup();
  ///
  bool End();
  ///
  inline const char *name() const { return "MCAna"; }

private:
  RtEvent* event;

  PMC_sp PiPlus;
  PMC_sp PiMinus;

  // K_S -> pi+ pi-
  DP_trait<2>::DPMC_sp K_short;
  DP_trait<2>::DPMC_sp K_tst;

}; // end of MCAna
#endif

