#ifndef __MCAna2_HH
#define __MCAna2_HH
// ********************************************************************
//
// source:
//
// type:      source code
//
// created:   Die Aug 14 10:33:50 MEST 2001
//
// author:    glebe
//
// Description: Header file of a MC analysis job
//
// changes:
//
// ********************************************************************

#include "interfaces/AnalysisIf.hh"

class TH1F;
class TH2F;
class TNtuple;
class RtEvent;

//==============================================================================
// MCAna2
//==============================================================================
class MCAna2 : public AnalysisIf {
public:
  /** @name --- Constructors --- */
  ///
  MCAna2(RtEvent* evt);
  ///
  virtual ~MCAna2() {}

  /** @name --- Access methods --- */
  ///
  bool EventSelect();
  ///
  bool DefineHistograms();
  ///
  bool DefinePattern();
  ///
  bool Event();
  ///
  bool EventCleanup();
  ///
  bool End();
  ///
  inline const char *name() const { return "MCAna2"; }

private:
  RtEvent* event;

  PMC_sp PiPlus;
  PMC_sp KMinus;

  // D_0 -> pi+ K-
  DP_trait<2>::DPMC_sp Dzero;

  TH1F* D0mass;

}; // end of MCAna
#endif

