#ifndef __Neutana_HH
#define __Neutana_HH
// ********************************************************************
//
// source:
//
// type:      source code
//
// created:   Mit Jul 11 13:45:50 MEST 2001
//
// author:    glebe
//
// Description: 
//
// changes:
//
// ********************************************************************

#include "interfaces/AnalysisIf.hh"

//#include "pattern/SPatternMatchContainer.hh"
#include "pattern/SDecayPatternMatchContainer.hh"
#include "pattern/SPatternExpression.hh"

class TH1F;
class TH2F;
class TNtuple;
class RtEvent;

//==============================================================================
// Neutana
//==============================================================================
class Neutana : public AnalysisIf {
public:
  /** @name --- Constructors --- */
  ///
  Neutana(RtEvent* evt) : event(evt) {}
  ///
  virtual ~Neutana() {}

  /** @name --- Access methods --- */
  ///
  bool EventSelect();
  ///
  bool DefineHistograms();
  ///
  bool DefinePattern();
  ///
  bool Event();
  ///
  bool EventCleanup();
  ///
  bool End();
  ///
  inline const char *name() const { return "Neutana"; }

private:
  RtEvent* event;
  
  PMC_sp Photon;

  // pi0 -> gammagamma
  DP_trait<2>::DPMC_sp pizero;

  // K0 -> pi0pi0
  DP_trait<2>::DPMC_sp kzero;

  TH1F*    nhits;
  TNtuple* PiZero;
  TNtuple* Kzero;
}; // end of Neutana
#endif

