#!/bin/bash
#
# Script to do prepare index.html & to get change log information
#
# T.Glebe MPI fuer Kernphysik Heidelberg.
#
##########################################################################

DIR=`dirname $0`
LOGFILE=${DIR}/ChangeLog.txt
PKGFILE=../PACKAGES

if [ -f $LOGFILE ]; then
  rm -f $LOGFILE
else
  touch $LOGFILE
fi

if [ ! -f ${PKGFILE} ]; then
  echo "Error in htmlprep.sh: cannot find ${PKGFILE}"
  exit
fi

cp ${DIR}/indextempl.html ${DIR}/index.html

# substitute project versions
echo "<pre>" >> $LOGFILE
for i in `cat ${PKGFILE} | awk '/^[ ]*[a-zA-Z]+/ { print $1","$2 }'`; do
    PKG=`echo $i | cut -d, -f1`
    VRS=`echo $i | cut -d, -f2`

    ( nxcvs.sh log $PKG $VRS | tr -d '<>'; echo) >> $LOGFILE

    PKG=`echo $PKG | tr -d '+'`VERSION
    mv ${DIR}/index.html ${DIR}/index.x
    awk '{gsub("'$PKG'","'$VRS'",$0); print $0}' ${DIR}/index.x > ${DIR}/index.html
    
done
echo "</pre>" >> $LOGFILE
rm -f ${DIR}/index.x
