#ifndef __RTYPEST_HH_
#define __RTYPEST_HH_

/* 
 * Definitions for a compiler understanding static member templates
 */


//
//
//

#define ClMyDefT2(name,T,id) \
private: \
   static TClass *fgIsA; \
public: \
   static const char *DeclFileName() { return __FILE__; } \
   static int DeclFileLine() { return __LINE__; } \
   static const char *ImplFileName(); \
   static int ImplFileLine(); \
   static Version_t Class_Version() { return id; } \
   static TClass *Class(); \
   static const char *Class_Name(); \
   virtual TClass *IsA() const { return name,T::Class(); } \
   virtual void ShowMembers(TMemberInspector &, char *); \
   virtual void Streamer(TBuffer &); \
   static void Dictionary();

#define _ClMyInitT2_(name,T1,T2) \
   extern void AddClass(const char *, Version_t, VoidFuncPtr_t); \
   extern void RemoveClass(const char *); \
   template <class T1,class T2> class _NAME2_(R__Init,name) { \
      public: \
         _NAME2_(R__Init,name) () { \
            AddClass(name<T1,T2>::Class_Name(), \
                     name<T1,T2>::Class_Version(), \
                     &name<T1,T2>::Dictionary); \
         } \
         _NAME3_(~,R__Init,name) () { \
            RemoveClass(name<T1,T2>::Class_Name()); \
         } \
   };

#define ClMyInstT2(name,T1,T2) \
   template <class T1,class T2> TBuffer &operator>>(TBuffer &, name<T1,T2> *&); \
   _ClMyInitT2_(name,T1,T2)

#define _ClMyImpT2_(name,T1,T2) \
   template <class T1,class T2> TClass *name<T1,T2>::Class() \
      { if (!fgIsA) name<T1,T2>::Dictionary(); return fgIsA; } \
   template <class T1,class T2> const char *name<T1,T2>::ImplFileName() \
      { return __FILE__; } \
   template <class T1,class T2> int name<T1,T2>::ImplFileLine() { return __LINE__; }\
   template <class T1,class T2> TClass *name<T1,T2>::fgIsA = 0;

#define ClMyImpT2(name,T1,T2) \
   template <class T1,class T2> void name<T1,T2>::Dictionary() { \
      TClass *c = CreateClass(Class_Name(),   Class_Version(), \
                              DeclFileName(), ImplFileName(), \
                              DeclFileLine(), ImplFileLine()); \
      fgIsA = c; \
   } \
   _ClMyImpT2_(name,T1,T2)


//
//
//

#define ClMyDefT3(name,T1,T2,id) \
private: \
   static TClass *fgIsA; \
public: \
   static const char *DeclFileName() { return __FILE__; } \
   static int DeclFileLine() { return __LINE__; } \
   static const char *ImplFileName(); \
   static int ImplFileLine(); \
   static Version_t Class_Version() { return id; } \
   static TClass *Class(); \
   static const char *Class_Name(); \
   virtual TClass *IsA() const { return name,T1,T2::Class(); } \
   virtual void ShowMembers(TMemberInspector &, char *); \
   virtual void Streamer(TBuffer &); \
   static void Dictionary();

#define _ClMyInitT3_(name,T1,T2,T3) \
   extern void AddClass(const char *, Version_t, VoidFuncPtr_t); \
   extern void RemoveClass(const char *); \
   template <class T1,class T2,class T3> class _NAME2_(R__Init,name) { \
      public: \
         _NAME2_(R__Init,name) () { \
            AddClass(name<T1,T2,T3>::Class_Name(), \
                     name<T1,T2,T3>::Class_Version(), \
                     &name<T1,T2,T3>::Dictionary); \
         } \
         _NAME3_(~,R__Init,name) () { \
            RemoveClass(name<T1,T2,T3>::Class_Name()); \
         } \
   };

#define ClMyInstT3(name,T1,T2,T3) \
 template <class T1,class T2,class T3> TBuffer &operator>>(TBuffer &, name<T1,T2,T3> *&);\
  _ClMyInitT3_(name,T1,T2,T3)

#define _ClMyImpT3_(name,T1,T2,T3) \
   template <class T1,class T2,class T3> TClass *name<T1,T2,T3>::Class() \
      { if (!fgIsA) name<T1,T2,T3>::Dictionary(); return fgIsA; } \
   template <class T1,class T2,class T3> \
     const char *name<T1,T2,T3>::ImplFileName() \
      { return __FILE__; } \
   template <class T1,class T2,class T3> int name<T1,T2,T3>::ImplFileLine() { return __LINE__; }\
   template <class T1,class T2,class T3> TClass *name<T1,T2,T3>::fgIsA = 0;

#define ClMyImpT3(name,T1,T2,T3) \
   template <class T1,class T2,class T3> void name<T1,T2,T3>::Dictionary() { \
      TClass *c = CreateClass(Class_Name(),   Class_Version(), \
                              DeclFileName(), ImplFileName(), \
                              DeclFileLine(), ImplFileLine()); \
      fgIsA = c; \
   } \
   _ClMyImpT3_(name,T1,T2,T3)

//
//
//

#define ClMyDefT4(name,T1,T2,T3,id) \
private: \
   static TClass *fgIsA; \
public: \
   static const char *DeclFileName() { return __FILE__; } \
   static int DeclFileLine() { return __LINE__; } \
   static const char *ImplFileName(); \
   static int ImplFileLine(); \
   static Version_t Class_Version() { return id; } \
   static TClass *Class(); \
   static const char *Class_Name(); \
   virtual TClass *IsA() const { return name,T1,T2,T3::Class(); } \
   virtual void ShowMembers(TMemberInspector &, char *); \
   virtual void Streamer(TBuffer &); \
   static void Dictionary();

#define _ClMyInitT4_(name,T1,T2,T3,T4) \
   extern void AddClass(const char *, Version_t, VoidFuncPtr_t); \
   extern void RemoveClass(const char *); \
   template <class T1,class T2,class T3,class T4> class _NAME2_(R__Init,name) { \
      public: \
         _NAME2_(R__Init,name) () { \
            AddClass(name<T1,T2,T3,T4>::Class_Name(), \
                     name<T1,T2,T3,T4>::Class_Version(), \
                     &name<T1,T2,T3,T4>::Dictionary); \
         } \
         _NAME3_(~,R__Init,name) () { \
            RemoveClass(name<T1,T2,T3,T4>::Class_Name()); \
         } \
   };

#define ClMyInstT4(name,T1,T2,T3,T4) \
 template <class T1,class T2,class T3,class T4> TBuffer &operator>>(TBuffer &, name<T1,T2,T3,T4> *&);\
  _ClMyInitT4_(name,T1,T2,T3,T4)

#define _ClMyImpT4_(name,T1,T2,T3,T4) \
   template <class T1,class T2,class T3,class T4> TClass *name<T1,T2,T3,T4>::Class() \
      { if (!fgIsA) name<T1,T2,T3,T4>::Dictionary(); return fgIsA; } \
   template <class T1,class T2,class T3,class T4> const char *name<T1,T2,T3,T4>::ImplFileName() \
      { return __FILE__; } \
   template <class T1,class T2,class T3,class T4> int name<T1,T2,T3,T4>::ImplFileLine() { return __LINE__; }\
   template <class T1,class T2,class T3,class T4> TClass *name<T1,T2,T3,T4>::fgIsA = 0;

#define ClMyImpT4(name,T1,T2,T3,T4) \
   template <class T1,class T2,class T3,class T4> void name<T1,T2,T3,T4>::Dictionary() { \
      TClass *c = CreateClass(Class_Name(),   Class_Version(), \
                              DeclFileName(), ImplFileName(), \
                              DeclFileLine(), ImplFileLine()); \
      fgIsA = c; \
   } \
   _ClMyImpT4_(name,T1,T2,T3,T4)



//==============================================================================
// definitions for templates inside namespaces
//==============================================================================
// The MyClassDefT2 must be located outside the namespace {} block!
#define _MyClassInitT_(namespace,name,Tmpl) \
   template <class Tmpl> class _NAME2_(R__Init,name) { \
      public: \
         _NAME2_(R__Init,name) () { \
            AddClass(namespace::name<Tmpl>::Class_Name(), \
                     namespace::name<Tmpl>::Class_Version(), \
                     &namespace::name<Tmpl>::Dictionary); \
         } \
         _NAME3_(~,R__Init,name) () { \
            RemoveClass(namespace::name<Tmpl>::Class_Name()); \
         } \
   };

#define MyClassDefT2(namespace,name,Tmpl) \
   template <class Tmpl> TBuffer &operator>>(TBuffer &, namespace::name<Tmpl> *&); \
   _MyClassInitT_(namespace,name,Tmpl)


#define _MyClMyInitT2_(namespace,name,T1,T2) \
   extern void AddClass(const char *, Version_t, VoidFuncPtr_t); \
   extern void RemoveClass(const char *); \
   template <class T1,class T2> class _NAME2_(R__Init,name) { \
      public: \
         _NAME2_(R__Init,name) () { \
            AddClass(namespace::name<T1,T2>::Class_Name(), \
                     namespace::name<T1,T2>::Class_Version(), \
                     &namespace::name<T1,T2>::Dictionary); \
         } \
         _NAME3_(~,R__Init,name) () { \
            RemoveClass(namespace::name<T1,T2>::Class_Name()); \
         } \
   };

#define MyClMyInstT2(namespace,name,T1,T2) \
   template <class T1,class T2> TBuffer &operator>>(TBuffer &, namespace::name<T1,T2> *&); \
   _MyClMyInitT2_(namespace,name,T1,T2)

#define _MyClMyInitT3_(namespace,name,T1,T2,T3) \
   extern void AddClass(const char *, Version_t, VoidFuncPtr_t); \
   extern void RemoveClass(const char *); \
   template <class T1,class T2,class T3> class _NAME2_(R__Init,name) { \
      public: \
         _NAME2_(R__Init,name) () { \
            AddClass(namespace::name<T1,T2,T3>::Class_Name(), \
                     namespace::name<T1,T2,T3>::Class_Version(), \
                     &namespace::name<T1,T2,T3>::Dictionary); \
         } \
         _NAME3_(~,R__Init,name) () { \
            RemoveClass(namespace::name<T1,T2,T3>::Class_Name()); \
         } \
   };

#define MyClMyInstT3(namespace,name,T1,T2,T3) \
 template <class T1,class T2,class T3> TBuffer &operator>>(TBuffer &, namespace::name<T1,T2,T3> *&);\
  _MyClMyInitT3_(namespace,name,T1,T2,T3)

#define _MyClMyInitT4_(namespace,name,T1,T2,T3,T4) \
   extern void AddClass(const char *, Version_t, VoidFuncPtr_t); \
   extern void RemoveClass(const char *); \
   template <class T1,class T2,class T3,class T4> class _NAME2_(R__Init,name) { \
      public: \
         _NAME2_(R__Init,name) () { \
            AddClass(namespace::name<T1,T2,T3,T4>::Class_Name(), \
                     namespace::name<T1,T2,T3,T4>::Class_Version(), \
                     &namespace::name<T1,T2,T3,T4>::Dictionary); \
         } \
         _NAME3_(~,R__Init,name) () { \
            RemoveClass(namespace::name<T1,T2,T3,T4>::Class_Name()); \
         } \
   };

#define MyClMyInstT4(namespace,name,T1,T2,T3,T4) \
 template <class T1,class T2,class T3,class T4> TBuffer &operator>>(TBuffer &, namespace::name<T1,T2,T3,T4> *&);\
  _MyClMyInitT4_(namespace,name,T1,T2,T3,T4)
#endif  /* RTYPEST_HH */
