#include <iostream>
#include "classes.hh"
#include "GsRelation.hh"

int main(void) {

  cout << " los gehts " << endl;

  Vertex v1(1),v2(2),v3(3);
  Track  t1(1),t2(2),t3(3);
  Hit    h1(1),h2(2),h3(3);
    
  GsPointer<Track> p1(t1,1), p2(t2,2), p3(t3,3);
  GsPointer<Vertex> pv1(v1,1), pv2(v2,2), pv3(v3,3);

  cout << " p1: " << p1 << " p2: " << p2 << " p3: " << p3 << endl;
  cout << " pv1: " << pv1 << " pv2: " << pv2 << " pv3: " << pv3 << endl;
  cout << " *p1: " << *p1 << " *pv2: " << *pv2 << endl;

#ifdef XXX
  cout << " Vertices: v1: " << v1 << " v2: " << v2 << " v3: " << v3
       << endl;
  cout << " Tracks: t1: " << t1 << " t2: " << t2 << " t3: " << t3
       << endl;
#endif

  cout << "create v1 <-> t1 relation: "
       << createRelation(v1,v1.out,t1,t1.bver)
       << endl;
  cout << "create v1 <-> t2 relation: "
       << createRelation(v1,v1.out,t2,t2.bver)
       << endl;
  cout << "create v1 <-> t3 relation: "
       << createRelation(v1,v1.out,t3,t3.bver)
       << endl;
  cout << "create t2 <-> v3 relation: "
       << createRelation(t2,t2.bver,v3,v3.out)
       << endl;
  cout << "create h1 <-> v1 relation: "
       << createRelation(h1,v1)
       << endl;
  cout << "create h1 <-> v2 relation: "
       << createRelation(h1,v2)
       << endl;
  cout << "create h1 <-> v3 relation: "
       << createRelation(h1,v3)
       << endl;
  cout << "create h2 <-> v1 relation: "
       << createRelation(h2,v1)
       << endl;

  cout << " v1-Relation: " << endl;
  for(GRelationIterator<Track> it = v1.out.begin(); it != v1.out.end(); ++it) {
    //    it->set_val(4);
//      //      Track& t = *it;
//      //      t.set_val(5);
    cout << *it << endl;
  }

  cout << " t1-Relation: " << endl;
  for(GRelationIterator<Vertex> it = t1.bver.begin(); it != t1.bver.end(); ++it) {
    cout << *it << endl;
  }

  cout << " v1.out.size: " << v1.out.size() << endl;
  cout << " v1.out[2]: " << v1.out[2] 
       << " *v1.out[2]: " << *v1.out[2]
       << endl;

  cout << " v1.out container: " << v1.out << endl;

  cout << " remove v1 <-> t1 relation: " << endl;
  removeRelation(v1,v1.out,t1,t1.bver);

  cout << " v1.out container: "  << v1.out << endl;
  cout << " t1.bver container: " << t1.bver << endl;

  cout << " v1 size via distance(): " << distance(v1.out.begin(),v1.out.end())
       << endl;

  cout << "create relation only in t1: " << endl;
  createSingleRelation(t1,v1);
  createSingleRelation(t1,v1);
  createSingleRelation(t1,v1);
  cout << " v1.out container: "  << v1.out << endl;
  cout << " t1.bver container: " << t1.bver << endl;

  cout << "remove relation only in t1: " << endl;
  removeSingleRelation(t1,v1);
  cout << " v1.out container: "  << v1.out << endl;
  cout << " t1.bver container: " << t1.bver << endl;
  cout << endl;

  createRelation(v1,v1.out,t1,t1.bver);
  cout << "inverse v1-Relation: " << endl;
  for(ReverseGRelationIterator<Track> it = v1.out.rbegin(); it != v1.out.rend(); ++it) {
    //    it->set_val(4);
    //      //      Track& t = *it;
    //      //      t.set_val(5);
    cout << *it << endl;
  }
  cout << endl;
  cout << "h1-Vertex relationen: " << h1.bver << endl;
  cout << "v1-Track relationen: "  << v1.out << endl;
  cout << "v1-Hit relationen: "    << v1.ecal << endl;


  if(true) {
    Hit h4(4);
    cout << " create temporary h4-v1 relation: " 
	 << createRelation(h4,v1) 
	 << endl;
    cout << " create temporary h4-v2 relation: " 
	 << createRelation(h4,v2) 
	 << endl;

    cout << "v1-Hit relationen: "    << v1.ecal << endl;
    cout << "v2-Hit relationen: "    << v1.ecal << endl;
  }
    
  cout << " now out of loop: " << endl;
  cout << "v1-Hit relationen: "    << v1.ecal << endl;

  cout << " ------------Start of GsPointer---- " << endl;
  cout << " v1<->p1: " << createSingleRelation(v1,v1.arteout,p1) << endl;
  cout << " v1<->p2: " << createSingleRelation(v1,v1.arteout,p2) << endl;
  cout << " v1<->p3: " << createSingleRelation(v1,v1.arteout,p3) << endl;

  cout << " GsPointer relation loop: " << endl;
  for(GRelationIterator<GsPointer<Track> > it = v1.arteout.begin();
      it != v1.arteout.end(); ++it) {
    GsPointer<Track> tr = *it;
    cout << " GsPointer<Track>: " << tr << endl;
    //    tr->set_val(10);
    cout << " Track: " << *tr << endl;
  }

  cout << " v1.arteout: " << v1.arteout << endl;
  cout << " remove v1<->p2: " << removeSingleRelation(v1,v1.arteout,p2) << endl;
  cout << " v1.arteout: " << v1.arteout << endl;

  cout << "ClueRelation loop: " << endl;
  for(ClueRelationIterator<Track> it = v1.arteout.begin();
      it != v1.arteout.end(); ++it) {
    GsPointer<Track> tr = *it;
    cout << " GsPointer<Track>: " << tr << endl;
    tr->set_val(10);
    cout << " Track: " << *tr << endl;
  }

  cout << endl;
  cout << " pv3<->: p1: " << createSingleRelation(pv3,p1) << endl;
  cout << " pv3<->: p3: " << createSingleRelation(pv3,p3) << endl;
  cout << " pv3->arteout: " << pv3->arteout << endl;

  cout << "ClueRelation loop: " << endl;
  for(ClueRelationIterator<Track> it = v3.arteout.begin();
      it != v3.arteout.end(); ++it) {
    GsPointer<Track> tr = *it;
    cout << " GsPointer<Track>: " << tr << endl;
    tr->set_val(55);
    cout << " Track: " << *tr << endl;
  }
  cout << " remove pv3<-> p1: " << removeSingleRelation(pv3,p1) << endl;
  cout << "ClueRelation loop: " << endl;
  for(ClueRelationIterator<Track> it = v3.arteout.begin();
      it != v3.arteout.end(); ++it) {
    GsPointer<Track> tr = *it;
    cout << " GsPointer<Track>: " << tr << endl;
    tr->set_val(55);
    cout << " Track: " << *tr << endl;
  }
  

  cout << " ----------------- End ------------ " << endl;
  cout << endl;

  return 0;
}
