#ifndef GROVER_WITHOUT_ARTE
#include "arte/arte.hh"
#endif

#include "grover/grover.hh"

//
// Part of the Grover package
// Please see the header file grover.hh
// for authors etc.
//
//
// Modifications:
// When?     Who?     What?
// YY-MM-DD  Name     Modification
// -----------------------------------------------------------------------------
// 01-03-13  Max      Added preprocessor directives
//

int GroverFillFromRTRA(GroverParticleList* gpl)
{
  ////////////////////////////////////////////////////////////////////////
  //
  // Fills a GroverParticleList with all RTRAs
  // Returns 0 if OK, -1 if none found.
  //
  ////////////////////////////////////////////////////////////////////////

  int errorflag = SUCCESS;

#ifndef GROVER_WITHOUT_ARTE
  for (ArteTable<RTRA>::iterator irtra = ArteTable<RTRA>::begin();
       irtra != ArteTable<RTRA>::end(); ++irtra) {
    if (irtra->hsi > 0) { // particles without VDS hits are ignored
      GroverParticle temp(irtra);
      gpl->push_back(temp);
    }
  }
  if (gpl->empty()) errorflag = FAILURE;
#endif

  return errorflag;
}
