#ifndef __ANALYSISIF_HH
#define __ANALYSISIF_HH
// ********************************************************************
//
// source:
//
// type:      source code
//
// created:   28. Feb 2001
//
// author:    Thorsten Glebe
//            HERA-B Collaboration
//            Max-Planck-Institut fuer Kernphysik
//            Saupfercheckweg 1
//            69117 Heidelberg
//            Germany
//            E-mail: T.Glebe@mpi-hd.mpg.de
//
// Description: Analysis interface class
//
// changes:
// 28 Feb 2001 (TG) creation
//
// ********************************************************************

/** Abstract class which defines the minimal interface for an Analysis object

    @author T. Glebe
*/
//==============================================================================
// AnalysisIf
//==============================================================================
class AnalysisIf {
public:
  /** @name --- Access methods --- */
  /// an event selection
  virtual bool EventSelect() = 0;
  ///
  virtual bool DefineHistograms() = 0;
  ///
  virtual bool DefinePattern() = 0;
  ///
  virtual bool Event() = 0;
  ///
  virtual bool EventCleanup() = 0;
  ///
  virtual bool End() = 0;
  ///
  virtual const char* name() const = 0;
}; // end of AnalysisIf
#endif
