#ifndef __COLLISIONIF_HH
#define __COLLISIONIF_HH
// ********************************************************************
//
// source:
//
// type:      source code
//
// created:   22. Feb 2001
//
// author:    Thorsten Glebe
//            HERA-B Collaboration
//            Max-Planck-Institut fuer Kernphysik
//            Saupfercheckweg 1
//            69117 Heidelberg
//            Germany
//            E-mail: T.Glebe@mpi-hd.mpg.de
//
// Description: Object collision interface class
//
// changes:
// 22 Feb 2001 (TG) creation
//
// ********************************************************************

/** Abstract class which defines the minimal interface for Object collision
    detection.

    @author T. Glebe
*/
//==============================================================================
// CollisionIf
//==============================================================================
template <class T>
class CollisionIf {
public:
  /** @name --- Access methods --- */
  ///
  virtual bool collision(const T& rhs, const T& lhs) const = 0;
}; // end of CollisionIf
#endif
