// ********************************************************************
//
// source:
//
// type:      source code
//
// created:   04. Jul 2001
//
// author:    Thorsten Glebe
//            HERA-B Collaboration
//            Max-Planck-Institut fuer Kernphysik
//            Saupfercheckweg 1
//            69117 Heidelberg
//            Germany
//            E-mail: T.Glebe@mpi-hd.mpg.de
//
// Description: Vertex Interface Property objects
//
// changes:
// 04 Jul 2001 (TG) creation
//
// ********************************************************************
#include "interfaces/VertexIf.hh"
#include "pattern/SProperty.hh"

//==============================================================================
// VertexIf Pattern elements
//==============================================================================
const SPMember<VertexIf,float> vx      ( &VertexIf::vx , "vx"  );
const SPMember<VertexIf,float> vy      ( &VertexIf::vy , "vy"  );
const SPMember<VertexIf,float> vz      ( &VertexIf::vz , "vz"  );

const SPMember<VertexIf,float> vchi2   ( &VertexIf::chi2, "chi2" );
const SPMember<VertexIf,float> prob    ( &VertexIf::prob, "prob" );

const SPMember<VertexIf,unsigned short int> vndf      ( &VertexIf::ndf , "ndf"  );
