// ********************************************************************
//
// source:
//
// type:      source code
//
// created:   01. Feb 2001
//
// author:    Thorsten Glebe
//            HERA-B Collaboration
//            Max-Planck-Institut fuer Kernphysik
//            Saupfercheckweg 1
//            69117 Heidelberg
//            Germany
//            E-mail: T.Glebe@mpi-hd.mpg.de
//
// Description: ROOT specific class describing a decay pattern
//              match for RecoTracks and Vt++ vertices
//
// changes:
// 05 Feb 2001 (TG) creation
//
// ********************************************************************

#include <iostream>
#include "clue/cluearte.hh"  // needed by RecoTrack
#include "clue/RecoTrack.hh" // needed by SmartPointer->print
#include "pattern/DecayPatternMatch.hh"
#include "pattern/DecayPattern.hh"
#include "pattern/SmartPointer.hh"

//==============================================================================
// Constructors
//==============================================================================
DecayPatternMatch::DecayPatternMatch() : DecayPatternMatchBase()
{}

DecayPatternMatch::DecayPatternMatch(const VERTEX::Vertex& v,
				     const DecayPattern& vpat,
				     bool cc) :
  DecayPatternMatchBase(v, vpat, cc)
{}

DecayPatternMatch::DecayPatternMatch(const SmartPointer<VERTEX::Vertex>& v,
				     const SmartPointer<DPatternBase>& vpat,
				     bool cc) :
  DecayPatternMatchBase(v, vpat, cc)
{}

DecayPatternMatch::~DecayPatternMatch()
{}

#ifdef USE_ROOT
ClassImp(DecayPatternMatch)
#endif
