// ********************************************************************
//
// source:
//
// type:      source code
//
// created:   20. Jul 1997
//
// author:    Thorsten Glebe
//            HERA-B Collaboration
//            Max-Planck-Institut fuer Kernphysik
//            Saupfercheckweg 1
//            69117 Heidelberg
//            Germany
//            E-mail: T.Glebe@mpi-hd.mpg.de
//
// Description: Routine which takes a GCombiner and vertexes.
//
// changes:
// 30 Jan 2001 (TG) creation
//
// ********************************************************************
#include "pattern/FindVertex.hh"
#include "clue/cluearte.hh"
#include "clue/RecoTrack.hh"
#include "pattern/PatternMatch.hh"
#include "vt++/Vt++.hh"

using namespace VERTEX;

#ifdef XXX
//==============================================================================
// collision function for Pattern matches
//==============================================================================
bool collision(GCombinerIterator<PM_l>& rhs) {
  typedef GC_trait<PM_l>::GCombination_cit GCombination_cit;
  typedef PM_l::value_type Val_t;

  const GCombination_cit vend = rhs.end();
  for(GCombination_cit cit = rhs.begin(); cit!= vend; ++cit) {

    const RecoTrack* rtrack = &(**cit)->getTrack();

    GCombination_cit cit2 = cit;
    for( ++cit2; cit2 != vend; ++cit2 ) {
      // attention: we compare RecoTrack pointers!
      if(rtrack == &((**cit2)->getTrack())) {
	cout << " found collision! " << endl;
        return true;
      }
    }
  }
  //  cout << endl;
  return false;
}

//==============================================================================
// findPattern
//==============================================================================
bool findPattern(const PMCombiner& source, PMCombiner& target) {
  // if there is only one list in source, skip vertexing.
  if(source.size() <= 1) { 
    target = source; 
    return true;
  }

  const PMCombiner_it end = source.end();
  for(PMCombiner_it it = source.begin(); it != end; ++it) {
    if(collision(it)) continue;
    
    const RecoTrack& r1 = (*it[0])->getTrack();
    const RecoTrack& r2 = (*it[1])->getTrack();

    Track t1(r1), t2(r2);

//      cout << " RecoTrack 0: " << r1 << endl;
//      cout << " RecoTrack 1: " << r2 << endl;
    cout << " Track 0: " << t1 << endl;
    cout << " Track 1: " << t2 << endl;

    Vertex v(t1,t2);
    if(v.findVertexVt() == true && v.prob() > 0.1) {
      cout << " Vertex found: (" << v.prob() << ") " << v << endl;
    }
  }
  return true;
}
#endif
